controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\FormRegister;
use app\models\Users;
use yii\widgets\ActiveForm;



class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /* public function actionBlog()
    {
        return $this->render('blog');
    }*/

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    
    private function randKey($str='', $long=0)
    {
        $key = null;
        $str = str_split($str);
        $start = 0;
        $limit = count($str)-1;
        for($x=0; $x<$long; $x++)
        {
            $key .= $str[rand($start, $limit)];
        }
        return $key;
    }
  
    public function actionConfirm()
    {
       $table = new Users;
       if (Yii::$app->request->get())
       {
           //Obtenemos el valor de los parámetros get
           $id = Html::encode($_GET["id"]);
           $authKey = $_GET["authKey"];

           if ((int) $id)
           {
               //Realizamos la consulta para obtener el registro
               $model = $table
               ->find()
               ->where("id=:id", [":id" => $id])
               ->andWhere("authKey=:authKey", [":authKey" => $authKey]);

               //Si el registro existe
               if ($model->count() == 1)
               {
                   $activar = Users::findOne($id);
                   $activar->activate = 1;
                   if ($activar->update())
                   {
                       echo "Enhorabuena registro llevado a cabo correctamente, redireccionando ...";
                       echo "<meta http-equiv='refresh' content='8; ".Url::toRoute("site/login")."'>";
                   }
                   else
                   {
                       echo "Ha ocurrido un error al realizar el registro, redireccionando ...";
                       echo "<meta http-equiv='refresh' content='8; ".Url::toRoute("site/login")."'>";
                   }
                }
               else //Si no existe redireccionamos a login
               {
                   return $this->redirect(["site/login"]);
               }
           }
           else //Si id no es un número entero redireccionamos a login
           {
               return $this->redirect(["site/login"]);
           }
       }
    }
    
     public function checkRegister($table, $model)
    {
        //Si el registro es guardado correctamente
            if ($table->insert())
            {              
                $user = $table->find()->where(["email" => $model->email])->one();
                $id = urlencode($user->id);
                $authKey = urlencode($user->authKey);

                $subject = "Confirmar registro";
                $body = "<h1>Haga click en el siguiente enlace para finalizar tu registro</h1>";
                $body .= "<a href='http://http://localhost/dam2/netso/web/index.php?r=site/confirm&id=".$id."&authKey=".$authKey."'>Confirmar</a>";

                //Enviamos el correo
                Yii::$app->mailer->compose()
                ->setTo($user->email)
                ->setFrom([Yii::$app->params["adminEmail"] => Yii::$app->params["title"]])
                ->setSubject($subject)
                ->setHtmlBody($body)
                ->send();

                $model->username = null;
                $model->email = null;
                $model->password = null;
                $model->password_repeat = null;

                $msg = "Enhorabuena, ahora sólo falta que confirmes tu registro en tu cuenta de correo";
            } else 
            {
                $msg = "Ha ocurrido un error al llevar a cabo tu registro";
            }
    }
    
     public function actionRegister()
    {     
     $model = new FormRegister;

     //Validación mediante ajax
     if ($model->load(Yii::$app->request->post()) && Yii::$app->request->isAjax)
           {
               Yii::$app->response->format = Response::FORMAT_JSON;
               return ActiveForm::validate($model);
           }
     //Validación cuando el formulario es enviado vía post
     //Esto sucede cuando la validación ajax se ha llevado a cabo correctamente
     //También previene por si el usuario tiene desactivado javascript y la
     //validación mediante ajax no puede ser llevada a cabo
     if ($model->load(Yii::$app->request->post()))
     {
        if($model->validate())
        {
            //Preparamos la consulta para guardar el usuario
            $table = new Users;
            $table->username = $model->username;
            $table->email = $model->email;
            //Encriptamos el password
            $table->password = crypt($model->password, Yii::$app->params["salt"]);
            //Creamos una cookie para autenticar al usuario cuando decida recordar la sesión, esta misma
            //clave será utilizada para activar el usuario
            $table->authKey = $this->randKey("abcdef0123456789", 200);
            //Creamos un token de acceso único para el usuario
            $table->accessToken = $this->randKey("abcdef0123456789", 200);
            //Método para comprobar y registrar el usuario
            checkRegister($table, $model);             
        }
        else
        {
            $model->getErrors();
        }
     }
     return $this->render("register", ["model" => $model]);
    }
   
}

controllers/WorksController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Ciclista;
use app\models\Works;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * CiclistaController implements the CRUD actions for Ciclista model.
 */
class WorksController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Ciclista models.
     * @return mixed
     */
    public function actionBlog()
    {
        
        $title = Works::find()->select('title')->all();
        $content = Works::find()->select('content')->all();
        $id = Works::find()->select('id')->all();
        $dataProvider = new ActiveDataProvider([
            'query' => Works::find(),
            
        ]);

        return $this->render('blog', [
            'dataProvider' => $dataProvider,
            'title' => $title,
            'content' => $content,
            'id' => $id,
            
        ]);
    }

    /**
     * Displays a single Ciclista model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
  /*  public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }*/
    
    public function actionView($id) {
        $id = (int) $id;
        $work = Works::find()->where(['id' => $id])->one();
        
        if (!$work) {
            throw new NotFoundHttpException(Yii::t('app', 'The post not found'));
        }
        
      /*  if ($work->status != Constant::STATUS_PUBLISHED && (!Helper::isOwner($work->created_by) && !Helper::isAdmin())) {
            throw new NotFoundHttpException(Yii::t('app', 'The post is not published.'));
        }
        elseif ($work->status == Constant::STATUS_PUBLISHED && $work->published_time > time() && (!Helper::isOwner($work->created_by) && !Helper::isAdmin())) {
            throw new NotFoundHttpException(Yii::t('app', 'The post is not published.'));
        }*/

        return $this->render('view', [
                    'model' => $work,
                    'id' => $id,
        ]);
    }

    /**
     * Creates a new Ciclista model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new \app\models\Works();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Ciclista model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
       

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'ID' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
            'id' => $model->id,
        ]);
    }

    /**
     * Deletes an existing Ciclista model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Ciclista model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Ciclista the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Works::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
    }
  
}

views/layouts/headers.php
<!--
	Author: W3layouts
	Author URL: http://w3layouts.com
	License: Creative Commons Attribution 3.0 Unported
	License URL: http://creativecommons.org/licenses/by/3.0/
-->

<?php

/* @var $this \yii\web\View */
/* @var $content string */

use yii\helpers\Html;
use yii\helpers\Url;


 $url = $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
?>

<!DOCTYPE html>
<html lang="es">
<head>
<title>NetSo</title>
	
	<!-- Meta tag Keywords -->
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<meta charset="utf-8">
	<meta name="keywords" content="Netso página web dedicada a la libertad de expresión y pensamiento." />
	<script type="application/x-javascript">
		addEventListener("load", function () {
			setTimeout(hideURLbar, 0);
		}, false);

		function hideURLbar() {
			window.scrollTo(0, 1);
		}
	</script>
	<!--// Meta tag Keywords -->	
	
	<!-- web-fonts -->
	<link href="//fonts.googleapis.com/css?family=Alegreya+Sans:100,100i,300,300i,400,400i,500,500i,700,700i,800,800i,900,900i&amp;subset=cyrillic,cyrillic-ext,greek,greek-ext,latin-ext,vietnamese" rel="stylesheet">
	<!-- //web-fonts -->
	
</head>

<body>
<!-- Navigation -->
<header>
	<div class="top-nav">
		<!--<div class="container">-->
			<nav class="navbar navbar-expand-lg navbar-light">
                            <a href="<?= Url::toRoute('site/index');?>" title="Vuelta al inicio" id="logo">
                                <img src="<?= \Yii::getAlias('@web/images/logotipo-netso.png') ?>" alt="NetSo logo" />
                            </a>                            
				<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
				<span class="navbar-toggler-icon"></span>
				</button>

				<div class="collapse navbar-collapse justify-content-center pr-md-4" id="navbarSupportedContent">
					<ul class="navbar-nav ml-auto">
						<li class="nav-item">
							<a class="nav-link" href="<?= Url::toRoute('site/index');?>">Inicio <span class="sr-only">(current)</span></a>
						</li>
						<li class="nav-item">
							<a class="nav-link" href="<?= Url::toRoute('site/about');?>" >Conócenos</a>-
						</li>
                                               
						<li class="nav-item">
                                                    
							<a href="<?= Url::toRoute('site/contact');?>" class="nav-link">Contacto</a>							
						</li>
                                                <li class="nav-item">
                                                <?php
                                                if (Yii::$app->user->isGuest){                                                    
                                                   /* Html::tag('a', ['/site/index'], ['class' => ['nav-link']]); */
                                                ?>
                                                <a class="nav-link" href="<?= Url::toRoute('site/register');?>">Registro</a>
                                                <?php
                                                } else {
                                                ?>
                                                     <a class="nav-link" href="<?= Url::toRoute('site/login');?>">Perfil</a>
                                                <?php
                                                 } ?>
                                                </li>
                                                <li class="nav-item">
							<a href="<?= Url::toRoute('works/blog');?>" class="nav-link">Blog</a>							
						</li>
                                                <ul class="nav navbar-nav navbar-right">
                                                    <li class="dropdown">
                                                        <a href="#" class="nav-link dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">Lenguaje <span class="caret"></span></a>
                                                        
                                                        <ul class="dropdown-menu" role="menu">
                                                            <li>
                                                                <?= Html::a(Html::img('@web/images/es_ES.png', ['class' => 'language']),['site/login']); ?>
                                                            </li>
                                                                <!--<a href="#" class="language" rel="it-IT"><img src=" \Yii::getAlias('@web/images/es_ES.png') " alt="Italiano" /></a>-->
                                                            <li>
                                                                <?= Html::a(Html::img('@web/images/en_US.png', ['class' => 'language']),['site/login']); ?>
                                                            </li>
                                                        </ul>
                                                    </li>
                                                </ul>    
					</ul>
				</div>
			</nav>
		<!--</div>-->
	</div>
</header>

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;
use yii\helpers\Url;        

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?php    
    $this->registerJsFile(
    '@web/js/jquery-3.5.1.min.js',
    );
     $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    <?php
    
    ?>

    <!--<div class="container">-->
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    <!--</div>-->
</div>

<footer class="footer">
    <div class="container">
       
            <div class="col-lg-5" >
                <a href="<?= Url::toRoute('site/index');?>" title="Vuelta al inicio" id="logo">
                    <img src="<?= \Yii::getAlias('@web/images/logotipo-netso.png') ?>" class="img-fluid footer-logo" alt="NetSo logo" />
                </a> 
                <p class="pull-left">&copy; Compañía NetSo <?= date('Y') ?>.<small>Todos los derechos reservados.</small></p>
            </div>
            <div class="col-lg-3" ></div>           
           <div class="col-lg-2" >
               <p><u>Mapa del Sitio</u></p>
                            <ul class="vlist">
                                <li><a href="index.html">Inicio</a></li><br>
                                <li><a href="services.html">Conócenos</a></li><br>
                                <li><a href="gallery.html">Contacto</a></li><br>
                                <li><a href="error.html">Blog</a></li><br>
                                <li><a href="contact.html">Registro</a></li>
                            </ul>
            </div>
            <div class="col-lg-2 justify-content-center">
               <p><u>Síguenos</u></p>
                            <ul class="d-flex mt-3">
                                <li><a href="#"><span class="fab fa-facebook"></span></a></li><br>
                                <li><a href="#"><span class="fab fa-twitter-square"></span></a></li><br>
                                <li><a href="#"><span class="fab fa-instagram"></span></a></li><br>
                                <li><a href="#"><span class="fab fa-linkedin"></span></a></li><br>
                                <li><a href="#"><span class="fab fa-google-plus-square"></span></a></li>
                            </ul>
            </div>            
    </div>
</footer>
 <!--<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
 <!--<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>-->
<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>